<template>
  <v-data-table
    :headers="headers"
    :search="search"
    :items="notes"
    class="elevation-1"
  >
    <template v-slot:top>
      <v-toolbar flat color="primary" class="">
        <v-toolbar-title class="white--text hidden-xs-only">List of Leave Types</v-toolbar-title>
        <v-divider
          class="mx-4 white hidden-xs-only"
          inset
          vertical
        ></v-divider>
        <v-spacer></v-spacer>
        <v-text-field
          v-model="search"
          class="mx-2 "
          append-icon="mdi-magnify"
          label="Search"
          solo
          dense
          single-line
          hide-details
        ></v-text-field>
        <v-btn
          color="white"
          tile
          outlined
          to="/leaveform"
        >
          <v-icon left>mdi-folder-plus</v-icon>Add Leave Type
        </v-btn>
      </v-toolbar>
    </template>
    <template v-slot:[`item.dateCreated`]="{ item }">
      <span class="caption black--text">{{ [item.dateCreated, 'x'] | moment('D MMM YY')}}</span>
    </template>
    <template v-slot:[`item.actions`]="{ item }">
      <v-btn icon
        class="secoundary--text mx-auto"
        :to="{ name: 'LeaveEdit', params: { id: `${item.id}` }}"
      >
        <v-icon small>mdi-pencil</v-icon>
      </v-btn>
      <v-btn icon
        class="secoundary--text mx-auto"
        @click="deleteNote(item)"
      >
        <v-icon small>mdi-delete</v-icon>
      </v-btn>
    </template>
  </v-data-table>
</template>
<script>
import { mapGetters } from 'vuex';
import { getAuthenticatedUser } from '@/fb';
import Note from '@/models/Note';
import UserNoteList from '@/models/UserNoteList';
// import * as firebase from 'firebase/app';

export default {
  data: () => ({
    leave: [],
    notes: [],
    search: '',
    disabled: true,
    prevBtnDisabled: true,
    nextBtnDisabled: true,
    headers: [
      {
        text: 'Leave Type',
        align: 'start',
        sortable: false,
        value: 'leavetype',
      },
      { text: 'description', value: 'description' },
      { text: 'dateCreated', value: 'dateCreated' },
      { text: 'Actions', value: 'actions', sortable: false },
    ],
  }),

  computed: {
    ...mapGetters({
      user: 'getUser',
    }),
  },

  watch: {
  },
  mounted() {
    getAuthenticatedUser().then((user) => {
      this.userNotes = new UserNoteList(
        { uid: user.uid, className: Note.getClassName() },
      );
      console.log('this function work');
      this.userNotes.fetch2({ orderBy: 'dateCreated', paginate: true })
        .then((page) => {
          this.notes = page;
          console.log('hello this is data you are seeing right now', page);
          // if (page.hasNext()) {
          //   this.nextBtnDisabled = false;
          //   console.log('@@222', this.nextBtnDisabled);
          // }
        });
    });
  },
  created() {
  },

  methods: {
    deleteNote(item) {
      // XXX: This only deletes the note from current page
      // but not from ListModel
      const index = this.notes.indexOf(item);
      this.notes[index].delete().then(() => {
        this.notes.splice(index, 1);
      });
    },
  },
};
</script>
